<?php

class Utils_Log {

    const LOG_DIR_CONTAINER = 'logs';
    const UPLOADS_DIR_CONTAINER = 'uploads';
    const marker = '//----------------------------------------------------------------------------';
    
    const TYPE_JAS = 'JobAlertSubscribe';
    const TYPE_NAS = 'NewsletterAlertSubscribe';
    const TYPE_TAF = 'TellAFriend';
    const TYPE_DATANODE = 'DataNodeRetrieval';
    const TYPE_AUTH = 'Authentication';
    const TYPE_NO_VACANCY = 'NoVacancyAttached';
    const TYPE_APPLY_BUILD = 'ApplyEmployeeBuild';
    const TYPE_APPLY_SEND = 'ApplyEmployeeSend';
    const TYPE_FETCH_PUBLICATION = 'PublicationRetrieval';
    const TYPE_FETCH_EMPLOYEE = 'EmployeeRetrieval';

    static function profilememory($text, $write = true) {
        return;
        $size = memory_get_usage(true);
        $base = log($size) / log(1024);
        $suffixes = array('', 'k', 'M', 'G', 'T');
        $precision = 2;
        $mb = round(pow(1024, $base - floor($base)), $precision) . $suffixes[floor($base)];
        $text = "$mb \t $text <br>\n";
        if ($write) {
            file_put_contents('memory_profile', $text, FILE_APPEND);
        } else {
            echo $text;
        }
    }

    static function streamWrite($message) {
        echo '<br>' . $message;
        @ob_flush();
        flush();
    }

    static function write($type, $object = false, $exception = false) {
        /*$filename = self::get_file();
        $content = self::format_data_as_string($type, $object, $exception);
        file_put_contents($filename, $content, FILE_APPEND);*/
    }

    static function info($content) {
        $filename = self::get_file();
        file_put_contents($filename, "-- INFO --\n", FILE_APPEND);
        file_put_contents($filename, $content, FILE_APPEND);
    }

    /**
     * Tests and tries to set up the right environment for storing the logs
     */
    static private function get_file() {
        $logDirPath = Carerix::$TMPDIR . DIRECTORY_SEPARATOR . Utils_Log::LOG_DIR_CONTAINER;

        if (!is_dir($logDirPath)) {
            if (!mkdir($logDirPath, 0777, true)) {
                return FALSE;
            }
        }

        $logFile = $logDirPath . DIRECTORY_SEPARATOR . date('Y') . '_' . date('m') . '_' . date('d') . '.log';

        if (file_exists($logFile) && filesize($logFile) > 2 * 1024 * 1024) {
            $destination = $logDirPath . '_' . time();
            rename($logFile, $destination);
        }

        return $logFile;
    }

    static public function isLocked() {
        $logDirPath = Carerix::$TMPDIR . DIRECTORY_SEPARATOR . Utils_Log::LOG_DIR_CONTAINER;

        if (!is_dir($logDirPath)) {
            if (!mkdir($logDirPath, 0777, true)) {
                return FALSE;
            }
        }
        $lockFile = $logDirPath . DIRECTORY_SEPARATOR . 'lock.it';
        if (file_exists($lockFile)) {
            return true;
        }
        return false;
    }

    static public function lockIt() {
        Environment_Settings::lockTheCron();
    }

    static public function unlockIt() {
        Environment_Settings::unlockIt();
    }

    /**
     * 
     * @param string $message
     * @param Carerix_Api_Rest_Entity $object
     * @param Exception $exception
     */
    static private function format_data_as_string($type, $object, $exception) {
        $agent = @$_SERVER['HTTP_USER_AGENT'];
        $ip = @$_SERVER['REMOTE_ADDR'];
        $method = @$_SERVER['REQUEST_METHOD'];
        $referrer = @$_SERVER['REQUEST_METHOD'];
        $time = date('Y-m-d H:i:s');

        $text = self::marker;

        $text .= "\nTIMESTAMP: $time\n";
        $text .= "TYPE: $type\n";
        $text .= "USER-AGENT: $agent\n";
        $text .= "METHOD: $method\n";
        $text .= "REFERRER: $referrer\n";
        $text .= "IP: $ip\n";

        try {
            $request = Carerix_Api_Rest_Entity::getLastRequest();
            $response = Carerix_Api_Rest_Entity::getLastResponse();

            $text .= "REQUEST: \n$request\n";
            $text .= "RESPONSE: \n$response\n";

            if ($exception) {
                $trace = $exception->getTraceAsString();
                $text .= "EXCEPTION TRACE: \n$trace\n";
            }
        } catch (Exception $ex) {
            echo 'hl';
        }

        $text .= self::marker . "\n\n";
        return $text;
    }

}
